#ifndef BACKWARDEULERTENTUSSCHER2006_HPP_
#define BACKWARDEULERTENTUSSCHER2006_HPP_

//! @file
//! 
//! This source file was generated from CellML.
//! 
//! Model: tentusscher_model_2006_epi
//! 
//! Processed by pycml - CellML Tools in Python
//!     (translate: 8406, pycml: 8196)
//! on Wed Apr  7 11:36:37 2010
//! 
//! <autogenerated>
//!
//! Generated by doing:
//!  cdchaste
//!  cd python/pycml
//!  ./translate.py -j ../../heart/src/odes/cellml/tentusscher_model_2006_epi_corrected_flooristim.out --Wu --row-lookup-method --conf=config.xml --use-chaste-stimulus --convert-interfaces -a -p -l ../../heart/src/odes/cellml/tentusscher_model_2006_epi_corrected_flooristim.cellml -c BackwardEulerTenTusscher2006 --assume-valid -o ../../heart/src/odes/ionicmodels/BackwardEulerTenTusscher2006.cpp

#include "ChasteSerialization.hpp"
#include <boost/serialization/base_object.hpp>
#include "AbstractBackwardEulerCardiacCell.hpp"
#include "AbstractStimulusFunction.hpp"

class BackwardEulerTenTusscher2006 : public AbstractBackwardEulerCardiacCell<7>
{
    friend class boost::serialization::access;
    template<class Archive>
    void serialize(Archive & archive, const unsigned int version)
    {
        archive & boost::serialization::base_object<AbstractBackwardEulerCardiacCell<7> >(*this);
    }
    
    // 
    // Settable parameters and readable variables
    // 
    double var_membrane__i_Stim;
    double var_membrane__i_K1;
    double var_membrane__i_to;
    double var_membrane__i_Kr;
    double var_membrane__i_Ks;
    double var_membrane__i_CaL;
    double var_membrane__i_NaK;
    double var_membrane__i_Na;
    double var_membrane__i_b_Na;
    double var_membrane__i_NaCa;
    double var_membrane__i_b_Ca;
    double var_membrane__i_p_K;
    double var_membrane__i_p_Ca;
    
public:
    double Get_membrane__i_Stim();
    double Get_membrane__i_K1();
    double Get_membrane__i_to();
    double Get_membrane__i_Kr();
    double Get_membrane__i_Ks();
    double Get_membrane__i_CaL();
    double Get_membrane__i_NaK();
    double Get_membrane__i_Na();
    double Get_membrane__i_b_Na();
    double Get_membrane__i_NaCa();
    double Get_membrane__i_b_Ca();
    double Get_membrane__i_p_K();
    double Get_membrane__i_p_Ca();
    BackwardEulerTenTusscher2006(boost::shared_ptr<AbstractIvpOdeSolver> /* unused; should be empty */, boost::shared_ptr<AbstractStimulusFunction> pIntracellularStimulus);
    ~BackwardEulerTenTusscher2006();
    
private:
    // Lookup table indices
    unsigned _table_index_0;
    double _factor_0;
    double* _lt_0_row;
    
    
public:
    void VerifyStateVariables();
    double GetIIonic();
    void ComputeResidual(double var_environment__time, const double rCurrentGuess[7], double rResidual[7]);
    void ComputeJacobian(double var_environment__time, const double rCurrentGuess[7], double rJacobian[7][7]);
protected:
    void UpdateTransmembranePotential(double var_environment__time);
    void ComputeOneStepExceptVoltage(double var_environment__time);
};


// Needs to be included last
#include "SerializationExportWrapper.hpp"
CHASTE_CLASS_EXPORT(BackwardEulerTenTusscher2006)

namespace boost
{
    namespace serialization
    {
        template<class Archive>
        inline void save_construct_data(
            Archive & ar, const BackwardEulerTenTusscher2006 * t, const unsigned int fileVersion)
        {
            const boost::shared_ptr<AbstractIvpOdeSolver> p_solver = t->GetSolver();
            const boost::shared_ptr<AbstractStimulusFunction> p_stimulus = t->GetStimulusFunction();
            ar << p_solver;
            ar << p_stimulus;
        }
        
        template<class Archive>
        inline void load_construct_data(
            Archive & ar, BackwardEulerTenTusscher2006 * t, const unsigned int fileVersion)
        {
            boost::shared_ptr<AbstractIvpOdeSolver> p_solver;
            boost::shared_ptr<AbstractStimulusFunction> p_stimulus;
            ar >> p_solver;
            ar >> p_stimulus;
            ::new(t)BackwardEulerTenTusscher2006(p_solver, p_stimulus);
        }
        
    }
    
}

#endif // BACKWARDEULERTENTUSSCHER2006_HPP_
