#ifndef _FoxModel2002Modified_
#define _FoxModel2002Modified_

/** @file
 *
 * Model: fox_model_2002
 *
 * Processed by pycml - CellML Tools in Python
 *     (translate: $Revision: 698 $, pycml: $Revision: 693 $)
 * on Wed May  9 07:45:54 2007
 *
 * <autogenerated>
 */

#include <cmath>
#include <cassert>
#include "AbstractCardiacCell.hpp"
#include "Exception.hpp"
#include "AbstractStimulusFunction.hpp"

/**
 * Generated from CellML, and P_Ca parameter modified.
 */
class FoxModel2002Modified : public AbstractCardiacCell
{
public:

    /**
     * Constructor
     *
     * @param pSolver is a pointer to the ODE solver
     * @param pIntracellularStimulus is a pointer to the intracellular stimulus
     */
    FoxModel2002Modified(boost::shared_ptr<AbstractIvpOdeSolver> pSolver,
                         boost::shared_ptr<AbstractStimulusFunction> pIntracellularStimulus);

    /**
     * Destructor
     */
    ~FoxModel2002Modified(void);

    /**
     * Calculates the ionic current
     *
     * @returns the total ionic current
     */
    double GetIIonic();

    /**
     * Evaluate the derivatives of the state variables
     *
     * @param var_Environment__time  the current time, in milliseconds
     * @param rY  current values of the state variables
     * @param rDY  to be filled in with derivatives
     */
    void EvaluateYDerivatives (
            double var_environment__time,
            const std::vector<double> &rY,
            std::vector<double> &rDY);
};

#endif
