//! @file
//!
//! This source file was generated from CellML.
//!
//! Model: Maleckar
//!
//! Processed by pycml - CellML Tools in Python
//!     (translate: 7385, pycml: 7152)
//! on Mon Dec 14 15:22:44 2009
//!
//! <autogenerated>

#include <cmath>
#include <cassert>
#include "Maleckar2009OdeSystem.hpp"
#include "Exception.hpp"
#include "OdeSystemInformation.hpp"

Maleckar2009OdeSystem::Maleckar2009OdeSystem(boost::shared_ptr<AbstractIvpOdeSolver> pSolver,
                            boost::shared_ptr<AbstractStimulusFunction> pIntracellularStimulus)
            : AbstractCardiacCell(pSolver, 30, 0, pIntracellularStimulus)
{
     mScaleFactorGks=1.0;
     mScaleFactorIto=1.0;
     mScaleFactorGkr=1.0;
     mScaleFactorGna=1.0;
     mScaleFactorAch=1e-24;
     mScaleFactorGNaK=1.0;
     mScaleFactorGNaCa=1.0;
     mScaleFactorGCaL=1.0;
     mScaleFactorGKur=1.0;
     mScaleFactorGK1=1.0;
     mScaleFactorAZD=0.0;
    // Time units: second
    //
    mpSystemInfo = OdeSystemInformation<Maleckar2009OdeSystem>::Instance();
    Init();

}

Maleckar2009OdeSystem::~Maleckar2009OdeSystem(void)
{
}

void Maleckar2009OdeSystem::SetScaleFactorGks(double sfgks)
{
    mScaleFactorGks=sfgks;
}
void Maleckar2009OdeSystem::SetScaleFactorIto(double sfito)
{
    mScaleFactorIto=sfito;
}
void Maleckar2009OdeSystem::SetScaleFactorGkr(double sfgkr)
{
    mScaleFactorGkr=sfgkr;
}
void Maleckar2009OdeSystem::SetScaleFactorGna(double sfgna)
{
    mScaleFactorGna=sfgna;
}
void Maleckar2009OdeSystem::SetScaleFactorAch(double sfach)
{
    mScaleFactorAch=sfach;
}
void Maleckar2009OdeSystem::SetScaleFactorGNaK(double sfgnak)
{
    mScaleFactorGNaK=sfgnak;
}
void Maleckar2009OdeSystem::SetScaleFactorGNaCa(double sfgnaca)
{
    mScaleFactorGNaCa=sfgnaca;
}
void Maleckar2009OdeSystem::SetScaleFactorGCaL(double sfgcal)
{
    mScaleFactorGCaL=sfgcal;
}
void Maleckar2009OdeSystem::SetScaleFactorGKur(double sfgkur)
{
    mScaleFactorGKur=sfgkur;
}
void Maleckar2009OdeSystem::SetScaleFactorGK1(double sfgk1)
{
    mScaleFactorGK1=sfgk1;
}
void Maleckar2009OdeSystem::SetScaleFactorAZD(double sfazd)
{
    mScaleFactorAZD=sfazd;
}

void Maleckar2009OdeSystem::VerifyStateVariables()
{}

double Maleckar2009OdeSystem::GetIIonic()
{
    std::vector<double>& rY = rGetStateVariables();
    double var_membrane__V = rY[0];
    // Units: millivolt; Initial value: -73.941851
    double var_sodium_current_m_gate__m = rY[1];
    // Units: dimensionless; Initial value: 0.003325
    double var_sodium_current_h1_gate__h1 = rY[2];
    // Units: dimensionless; Initial value: 0.875262
    double var_sodium_current_h2_gate__h2 = rY[3];
    // Units: dimensionless; Initial value: 0.870692
    double var_L_type_Ca_channel_d_L_gate__d_L = rY[4];
    // Units: dimensionless; Initial value: 0.000014
    double var_L_type_Ca_channel_f_L1_gate__f_L1 = rY[5];
    // Units: dimensionless; Initial value: 0.998578
    double var_L_type_Ca_channel_f_L2_gate__f_L2 = rY[6];
    // Units: dimensionless; Initial value: 0.998561
    double var_Ca_independent_transient_outward_K_current_r_gate__r = rY[7];
    // Units: dimensionless; Initial value: 0.001098
    double var_Ca_independent_transient_outward_K_current_s_gate__s = rY[8];
    // Units: dimensionless; Initial value: 0.948202
    double var_ultra_rapid_K_current_aur_gate__a_ur = rY[9];
    // Units: dimensionless; Initial value: 0.000371
    double var_ultra_rapid_K_current_iur_gate__i_ur = rY[10];
    // Units: dimensionless; Initial value: 0.966869
    double var_delayed_rectifier_K_currents_n_gate__n = rY[11];
    // Units: dimensionless; Initial value: 0.004661
    double var_delayed_rectifier_K_currents_pa_gate__pa = rY[12];
    // Units: dimensionless; Initial value: 0.000054
    double var_intracellular_ion_concentrations__Na_i = rY[13];
    // Units: millimolar; Initial value: 8.488527
    double var_intracellular_ion_concentrations__Ca_i = rY[14];
    // Units: millimolar; Initial value: 6.5e-5
    double var_intracellular_ion_concentrations__K_i = rY[15];
    // Units: millimolar; Initial value: 129.502075
    double var_intracellular_ion_concentrations__Ca_d = rY[16];
    // Units: millimolar; Initial value: 7.1e-5
    double var_cleft_space_ion_concentrations__Na_c = rY[22];
    // Units: millimolar; Initial value: 130.019282
    double var_cleft_space_ion_concentrations__Ca_c = rY[23];
    // Units: millimolar; Initial value: 1.814418
    double var_cleft_space_ion_concentrations__K_c = rY[24];
    // Units: millimolar; Initial value: 5.588239

    const double var_membrane__R = 8314.0;
    const double var_membrane__T = 306.15;
    const double var_membrane__F = 96487.0;
    const double var_membrane__Cm = 0.05;
    const double var_sodium_current__F = var_membrane__F;
    const double var_sodium_current__R = var_membrane__R;
    const double var_sodium_current__T = var_membrane__T;
    const double var_sodium_current__Na_c = var_cleft_space_ion_concentrations__Na_c;
    const double var_sodium_current__Na_i = var_intracellular_ion_concentrations__Na_i;
    const double var_sodium_current__E_Na = ((var_sodium_current__R * var_sodium_current__T) / var_sodium_current__F) * log(var_sodium_current__Na_c / var_sodium_current__Na_i);
    const double var_sodium_current__m = var_sodium_current_m_gate__m;
    const double var_sodium_current__h2 = var_sodium_current_h2_gate__h2;
    const double var_sodium_current__h1 = var_sodium_current_h1_gate__h1;
    const double var_sodium_current__V = var_membrane__V;
    const double var_sodium_current__P_Na = 0.0018;
    const double var_sodium_current__i_Na = mScaleFactorGna*(((var_sodium_current__P_Na * var_sodium_current__m * var_sodium_current__m * var_sodium_current__m * ((0.9 * var_sodium_current__h1) + (0.1 * var_sodium_current__h2)) * var_sodium_current__Na_c * var_sodium_current__V * var_sodium_current__F * var_sodium_current__F) / (var_sodium_current__R * var_sodium_current__T)) * (exp(((var_sodium_current__V - var_sodium_current__E_Na) * var_sodium_current__F) / (var_sodium_current__R * var_sodium_current__T)) - 1.0)) / (exp((var_sodium_current__V * var_sodium_current__F) / (var_sodium_current__R * var_sodium_current__T)) - 1.0);
    const double var_membrane__i_Na = var_sodium_current__i_Na;
    const double var_L_type_Ca_channel__k_Ca = 0.025;
    const double var_L_type_Ca_channel__Ca_d = var_intracellular_ion_concentrations__Ca_d;
    const double var_L_type_Ca_channel__f_Ca = var_L_type_Ca_channel__Ca_d / (var_L_type_Ca_channel__Ca_d + var_L_type_Ca_channel__k_Ca);
    const double var_L_type_Ca_channel__E_Ca_app = 60.0;
    const double var_L_type_Ca_channel__g_Ca_L = 6.75*mScaleFactorGCaL;
    const double var_L_type_Ca_channel__d_L = var_L_type_Ca_channel_d_L_gate__d_L;
    const double var_L_type_Ca_channel__f_L2 = var_L_type_Ca_channel_f_L2_gate__f_L2;
    const double var_L_type_Ca_channel__V = var_membrane__V;
    const double var_L_type_Ca_channel__f_L1 = var_L_type_Ca_channel_f_L1_gate__f_L1;
    const double var_L_type_Ca_channel__i_Ca_L = var_L_type_Ca_channel__g_Ca_L * var_L_type_Ca_channel__d_L * ((var_L_type_Ca_channel__f_Ca * var_L_type_Ca_channel__f_L1) + ((1.0 - var_L_type_Ca_channel__f_Ca) * var_L_type_Ca_channel__f_L2)) * (var_L_type_Ca_channel__V - var_L_type_Ca_channel__E_Ca_app);
    const double var_membrane__i_Ca_L = var_L_type_Ca_channel__i_Ca_L;
    const double var_Ca_independent_transient_outward_K_current__V = var_membrane__V;
    const double var_Ca_independent_transient_outward_K_current__g_t = 8.25*mScaleFactorIto;
    const double var_Ca_independent_transient_outward_K_current__F = var_membrane__F;
    const double var_Ca_independent_transient_outward_K_current__K_c = var_cleft_space_ion_concentrations__K_c;
    const double var_Ca_independent_transient_outward_K_current__T = var_membrane__T;
    const double var_Ca_independent_transient_outward_K_current__K_i = var_intracellular_ion_concentrations__K_i;
    const double var_Ca_independent_transient_outward_K_current__R = var_membrane__R;
    const double var_Ca_independent_transient_outward_K_current__E_K = ((var_Ca_independent_transient_outward_K_current__R * var_Ca_independent_transient_outward_K_current__T) / var_Ca_independent_transient_outward_K_current__F) * log(var_Ca_independent_transient_outward_K_current__K_c / var_Ca_independent_transient_outward_K_current__K_i);
    const double var_Ca_independent_transient_outward_K_current__r = var_Ca_independent_transient_outward_K_current_r_gate__r;
    const double var_Ca_independent_transient_outward_K_current__s = var_Ca_independent_transient_outward_K_current_s_gate__s;
    const double var_Ca_independent_transient_outward_K_current__i_t = var_Ca_independent_transient_outward_K_current__g_t * var_Ca_independent_transient_outward_K_current__r * var_Ca_independent_transient_outward_K_current__s * (var_Ca_independent_transient_outward_K_current__V - var_Ca_independent_transient_outward_K_current__E_K);
    const double var_membrane__i_t = var_Ca_independent_transient_outward_K_current__i_t;
    const double var_ultra_rapid_K_current__g_kur = 2.25*mScaleFactorGKur;
    const double var_ultra_rapid_K_current__V = var_membrane__V;
    const double var_ultra_rapid_K_current__E_K = var_Ca_independent_transient_outward_K_current__E_K;
    const double var_ultra_rapid_K_current__a_ur = var_ultra_rapid_K_current_aur_gate__a_ur;
    const double var_ultra_rapid_K_current__i_ur = var_ultra_rapid_K_current_iur_gate__i_ur;
    const double var_ultra_rapid_K_current__i_Kur = var_ultra_rapid_K_current__g_kur * var_ultra_rapid_K_current__a_ur * var_ultra_rapid_K_current__i_ur * (var_ultra_rapid_K_current__V - var_ultra_rapid_K_current__E_K);
    const double var_membrane__i_Kur = var_ultra_rapid_K_current__i_Kur;
    const double var_inward_rectifier__T = var_membrane__T;
    const double var_inward_rectifier__V = var_membrane__V;
    const double var_inward_rectifier__g_K1 = 3.1*mScaleFactorGK1;
    const double var_inward_rectifier__R = var_membrane__R;
    const double var_inward_rectifier__K_c = var_cleft_space_ion_concentrations__K_c;
    const double var_inward_rectifier__F = var_membrane__F;
    const double var_inward_rectifier__E_K = var_Ca_independent_transient_outward_K_current__E_K;
    const double var_inward_rectifier__i_K1 = (var_inward_rectifier__g_K1 * pow(var_inward_rectifier__K_c / 1.0, 0.4457) * (var_inward_rectifier__V - var_inward_rectifier__E_K)) / (1.0 + exp((1.5 * ((var_inward_rectifier__V - var_inward_rectifier__E_K) + 3.6) * var_inward_rectifier__F) / (var_inward_rectifier__R * var_inward_rectifier__T)));
    const double var_membrane__i_K1 = var_inward_rectifier__i_K1;
    const double var_delayed_rectifier_K_currents__V = var_membrane__V;
    const double var_delayed_rectifier_K_currents_pi_gate__V = var_delayed_rectifier_K_currents__V;
    const double var_delayed_rectifier_K_currents_pi_gate__pip = 1.0 / (1.0 + exp((var_delayed_rectifier_K_currents_pi_gate__V + 55.0) / 24.0));
    const double var_delayed_rectifier_K_currents__pip = var_delayed_rectifier_K_currents_pi_gate__pip;
    const double var_delayed_rectifier_K_currents_pa_gate__AZD = mScaleFactorAZD;
    const double var_delayed_rectifier_K_currents__AZD = var_delayed_rectifier_K_currents_pa_gate__AZD;
    const double var_delayed_rectifier_K_currents__factorAZD = (1.0 - (1.0 / (1.0 + exp((-(var_delayed_rectifier_K_currents__AZD - 0.6)) / 0.12)))) / 0.9933;
    const double var_delayed_rectifier_K_currents__E_K = var_Ca_independent_transient_outward_K_current__E_K;
    const double var_delayed_rectifier_K_currents__g_Kr = 0.5*mScaleFactorGkr;
    const double var_delayed_rectifier_K_currents__pa = var_delayed_rectifier_K_currents_pa_gate__pa;
    const double var_delayed_rectifier_K_currents__i_Kr = var_delayed_rectifier_K_currents__g_Kr * var_delayed_rectifier_K_currents__factorAZD * var_delayed_rectifier_K_currents__pa * var_delayed_rectifier_K_currents__pip * (var_delayed_rectifier_K_currents__V - var_delayed_rectifier_K_currents__E_K);
    const double var_membrane__i_Kr = var_delayed_rectifier_K_currents__i_Kr;
    const double var_delayed_rectifier_K_currents__n = var_delayed_rectifier_K_currents_n_gate__n;
    const double var_delayed_rectifier_K_currents__g_Ks = 1.0*mScaleFactorGks;
    const double var_delayed_rectifier_K_currents__i_Ks = var_delayed_rectifier_K_currents__g_Ks * var_delayed_rectifier_K_currents__n * (var_delayed_rectifier_K_currents__V - var_delayed_rectifier_K_currents__E_K);
    const double var_membrane__i_Ks = var_delayed_rectifier_K_currents__i_Ks;
    const double var_background_currents__E_Na = var_sodium_current__E_Na;
    const double var_background_currents__g_B_Na = 0.060599;
    const double var_background_currents__V = var_membrane__V;
    const double var_background_currents__i_B_Na = var_background_currents__g_B_Na * (var_background_currents__V - var_background_currents__E_Na);
    const double var_membrane__i_B_Na = var_background_currents__i_B_Na;
    const double var_background_currents__Ca_c = var_cleft_space_ion_concentrations__Ca_c;
    const double var_background_currents__R = var_membrane__R;
    const double var_background_currents__Ca_i = var_intracellular_ion_concentrations__Ca_i;
    const double var_background_currents__F = var_membrane__F;
    const double var_background_currents__T = var_membrane__T;
    const double var_background_currents__E_Ca = ((var_background_currents__R * var_background_currents__T) / (2.0 * var_background_currents__F)) * log(var_background_currents__Ca_c / var_background_currents__Ca_i);
    const double var_background_currents__g_B_Ca = 0.078681;
    const double var_background_currents__i_B_Ca = var_background_currents__g_B_Ca * (var_background_currents__V - var_background_currents__E_Ca);
    const double var_membrane__i_B_Ca = var_background_currents__i_B_Ca;
    const double var_sodium_potassium_pump__K_c = var_cleft_space_ion_concentrations__K_c;
    const double var_sodium_potassium_pump__pow_K_NaK_Na_15 = 36.4829;
    const double var_sodium_potassium_pump__Na_i = var_intracellular_ion_concentrations__Na_i;
    const double var_sodium_potassium_pump__pow_Na_i_15 = pow(var_sodium_potassium_pump__Na_i, 1.5);
    const double var_sodium_potassium_pump__V = var_membrane__V;
    const double var_sodium_potassium_pump__i_NaK_max = 68.55*mScaleFactorGNaK;
    const double var_sodium_potassium_pump__K_NaK_K = 1.0;
    const double var_sodium_potassium_pump__i_NaK = (((((var_sodium_potassium_pump__i_NaK_max * var_sodium_potassium_pump__K_c) / (var_sodium_potassium_pump__K_c + var_sodium_potassium_pump__K_NaK_K)) * var_sodium_potassium_pump__pow_Na_i_15) / (var_sodium_potassium_pump__pow_Na_i_15 + var_sodium_potassium_pump__pow_K_NaK_Na_15)) * (var_sodium_potassium_pump__V + 150.0)) / (var_sodium_potassium_pump__V + 200.0);
    const double var_membrane__i_NaK = var_sodium_potassium_pump__i_NaK;
    const double var_sarcolemmal_calcium_pump_current__i_CaP_max = 4.0;
    const double var_sarcolemmal_calcium_pump_current__k_CaP = 0.0002;
    const double var_sarcolemmal_calcium_pump_current__Ca_i = var_intracellular_ion_concentrations__Ca_i;
    const double var_sarcolemmal_calcium_pump_current__i_CaP = (var_sarcolemmal_calcium_pump_current__i_CaP_max * var_sarcolemmal_calcium_pump_current__Ca_i) / (var_sarcolemmal_calcium_pump_current__Ca_i + var_sarcolemmal_calcium_pump_current__k_CaP);
    const double var_membrane__i_CaP = var_sarcolemmal_calcium_pump_current__i_CaP;
    const double var_Na_Ca_ion_exchanger_current__Ca_c = var_cleft_space_ion_concentrations__Ca_c;
    const double var_Na_Ca_ion_exchanger_current__Na_i = var_intracellular_ion_concentrations__Na_i;
    const double var_Na_Ca_ion_exchanger_current__gamma_Na = 0.45;
    const double var_Na_Ca_ion_exchanger_current__Ca_i = var_intracellular_ion_concentrations__Ca_i;
    const double var_Na_Ca_ion_exchanger_current__K_NaCa = 0.0374842*mScaleFactorGNaCa;
    const double var_Na_Ca_ion_exchanger_current__F = var_membrane__F;
    const double var_Na_Ca_ion_exchanger_current__d_NaCa = 0.0003;
    const double var_Na_Ca_ion_exchanger_current__R = var_membrane__R;
    const double var_Na_Ca_ion_exchanger_current__Na_c = var_cleft_space_ion_concentrations__Na_c;
    const double var_Na_Ca_ion_exchanger_current__V = var_membrane__V;
    const double var_Na_Ca_ion_exchanger_current__T = var_membrane__T;
    const double var_Na_Ca_ion_exchanger_current__i_NaCa = (var_Na_Ca_ion_exchanger_current__K_NaCa * ((var_Na_Ca_ion_exchanger_current__Na_i * var_Na_Ca_ion_exchanger_current__Na_i * var_Na_Ca_ion_exchanger_current__Na_i * var_Na_Ca_ion_exchanger_current__Ca_c * exp((var_Na_Ca_ion_exchanger_current__F * var_Na_Ca_ion_exchanger_current__V * var_Na_Ca_ion_exchanger_current__gamma_Na) / (var_Na_Ca_ion_exchanger_current__R * var_Na_Ca_ion_exchanger_current__T))) - (var_Na_Ca_ion_exchanger_current__Na_c * var_Na_Ca_ion_exchanger_current__Na_c * var_Na_Ca_ion_exchanger_current__Na_c * var_Na_Ca_ion_exchanger_current__Ca_i * exp(((var_Na_Ca_ion_exchanger_current__gamma_Na - 1.0) * var_Na_Ca_ion_exchanger_current__V * var_Na_Ca_ion_exchanger_current__F) / (var_Na_Ca_ion_exchanger_current__R * var_Na_Ca_ion_exchanger_current__T))))) / (1.0 + (var_Na_Ca_ion_exchanger_current__d_NaCa * ((var_Na_Ca_ion_exchanger_current__Na_c * var_Na_Ca_ion_exchanger_current__Na_c * var_Na_Ca_ion_exchanger_current__Na_c * var_Na_Ca_ion_exchanger_current__Ca_i) + (var_Na_Ca_ion_exchanger_current__Na_i * var_Na_Ca_ion_exchanger_current__Na_i * var_Na_Ca_ion_exchanger_current__Na_i * var_Na_Ca_ion_exchanger_current__Ca_c))));
    const double var_membrane__i_NaCa = var_Na_Ca_ion_exchanger_current__i_NaCa;
    const double var_ACh_dependent_K_current__Cm = var_membrane__Cm;
    const double var_ACh_dependent_K_current__V = var_membrane__V;
    const double var_ACh_dependent_K_current__E_K = var_Ca_independent_transient_outward_K_current__E_K;
    const double var_ACh_dependent_K_current__ACh = mScaleFactorAch;
    const double var_ACh_dependent_K_current__i_KACh = (10000.0 / (1.0 + ((9.13652 * pow(1.0, 0.477811)) / pow(var_ACh_dependent_K_current__ACh, 0.477811)))) * (0.0517 + (0.4516 / (1.0 + exp((var_ACh_dependent_K_current__V + 59.53) / 17.18)))) * (var_ACh_dependent_K_current__V - var_ACh_dependent_K_current__E_K) * var_ACh_dependent_K_current__Cm;
    const double var_membrane__i_KACh = var_ACh_dependent_K_current__i_KACh;



    double i_ion_in_pA  = (var_membrane__i_Na+var_membrane__i_Ca_L+var_membrane__i_t+var_membrane__i_Kur+var_membrane__i_K1+var_membrane__i_Kr+var_membrane__i_Ks+var_membrane__i_B_Na+var_membrane__i_B_Ca+var_membrane__i_NaK+var_membrane__i_CaP+var_membrane__i_NaCa+var_membrane__i_KACh);

    /***
     * Convert to microA/cm2.
     *
     * Cm needs to be converted from nF to  microF (to cancel with mono/bidomain Cm) --> 10^-3 at the denominator
     * Currents are in pA and needs to be converted to microA --> 10^-6 at the numerator.
     * So we divide by (Cm*1000)
     */
    double i_ion_in_microAmp_per_cm_square = i_ion_in_pA/(var_membrane__Cm*1000);
    return i_ion_in_microAmp_per_cm_square;
}

void Maleckar2009OdeSystem::EvaluateYDerivatives(
        double var_environment__time,
        const std::vector<double> &rY,
        std::vector<double> &rDY)
{
    // Inputs:
    // Time units: second
    var_environment__time *= 0.001;
    double var_membrane__V = rY[0];
    // Units: millivolt; Initial value: -73.941851
    double var_sodium_current_m_gate__m = rY[1];
    // Units: dimensionless; Initial value: 0.003325
    double var_sodium_current_h1_gate__h1 = rY[2];
    // Units: dimensionless; Initial value: 0.875262
    double var_sodium_current_h2_gate__h2 = rY[3];
    // Units: dimensionless; Initial value: 0.870692
    double var_L_type_Ca_channel_d_L_gate__d_L = rY[4];
    // Units: dimensionless; Initial value: 0.000014
    double var_L_type_Ca_channel_f_L1_gate__f_L1 = rY[5];
    // Units: dimensionless; Initial value: 0.998578
    double var_L_type_Ca_channel_f_L2_gate__f_L2 = rY[6];
    // Units: dimensionless; Initial value: 0.998561
    double var_Ca_independent_transient_outward_K_current_r_gate__r = rY[7];
    // Units: dimensionless; Initial value: 0.001098
    double var_Ca_independent_transient_outward_K_current_s_gate__s = rY[8];
    // Units: dimensionless; Initial value: 0.948202
    double var_ultra_rapid_K_current_aur_gate__a_ur = rY[9];
    // Units: dimensionless; Initial value: 0.000371
    double var_ultra_rapid_K_current_iur_gate__i_ur = rY[10];
    // Units: dimensionless; Initial value: 0.966869
    double var_delayed_rectifier_K_currents_n_gate__n = rY[11];
    // Units: dimensionless; Initial value: 0.004661
    double var_delayed_rectifier_K_currents_pa_gate__pa = rY[12];
    // Units: dimensionless; Initial value: 0.000054
    double var_intracellular_ion_concentrations__Na_i = rY[13];
    // Units: millimolar; Initial value: 8.488527
    double var_intracellular_ion_concentrations__Ca_i = rY[14];
    // Units: millimolar; Initial value: 6.5e-5
    double var_intracellular_ion_concentrations__K_i = rY[15];
    // Units: millimolar; Initial value: 129.502075
    double var_intracellular_ion_concentrations__Ca_d = rY[16];
    // Units: millimolar; Initial value: 7.1e-5
    double var_intracellular_Ca_buffering__O_C = rY[17];
    // Units: dimensionless; Initial value: 0.026604
    double var_intracellular_Ca_buffering__O_TC = rY[18];
    // Units: dimensionless; Initial value: 0.012843
    double var_intracellular_Ca_buffering__O_TMgC = rY[19];
    // Units: dimensionless; Initial value: 0.190077
    double var_intracellular_Ca_buffering__O_TMgMg = rY[20];
    // Units: dimensionless; Initial value: 0.714719
    double var_cleft_space_ion_concentrations__Na_c = rY[22];
    // Units: millimolar; Initial value: 130.019282
    double var_cleft_space_ion_concentrations__Ca_c = rY[23];
    // Units: millimolar; Initial value: 1.814418
    double var_cleft_space_ion_concentrations__K_c = rY[24];
    // Units: millimolar; Initial value: 5.588239
    double var_Ca_handling_by_the_SR__Ca_rel = rY[25];
    // Units: millimolar; Initial value: 0.630471
    double var_Ca_handling_by_the_SR__Ca_up = rY[26];
    // Units: millimolar; Initial value: 0.646226
    double var_Ca_handling_by_the_SR__O_Calse = rY[27];
    // Units: dimensionless; Initial value: 0.43071
    double var_Ca_handling_by_the_SR__F1 = rY[28];
    // Units: dimensionless; Initial value: 0.45453
    double var_Ca_handling_by_the_SR__F2 = rY[29];
    // Units: dimensionless; Initial value: 0.002665

    VerifyStateVariables();

    // Mathematics
    const double var_membrane__R = 8314.0;
    const double var_membrane__T = 306.15;
    const double var_membrane__F = 96487.0;
    const double var_membrane__Cm = 0.05;
    const double var_sodium_current__F = var_membrane__F;
    const double var_sodium_current__R = var_membrane__R;
    const double var_sodium_current__T = var_membrane__T;
    const double var_sodium_current__Na_c = var_cleft_space_ion_concentrations__Na_c;
    const double var_sodium_current__Na_i = var_intracellular_ion_concentrations__Na_i;
    const double var_sodium_current__E_Na = ((var_sodium_current__R * var_sodium_current__T) / var_sodium_current__F) * log(var_sodium_current__Na_c / var_sodium_current__Na_i);
    const double var_sodium_current__m = var_sodium_current_m_gate__m;
    const double var_sodium_current__h2 = var_sodium_current_h2_gate__h2;
    const double var_sodium_current__h1 = var_sodium_current_h1_gate__h1;
    const double var_sodium_current__V = var_membrane__V;
    const double var_sodium_current__P_Na = 0.0018;
    const double var_sodium_current__i_Na = mScaleFactorGna*(((var_sodium_current__P_Na * var_sodium_current__m * var_sodium_current__m * var_sodium_current__m * ((0.9 * var_sodium_current__h1) + (0.1 * var_sodium_current__h2)) * var_sodium_current__Na_c * var_sodium_current__V * var_sodium_current__F * var_sodium_current__F) / (var_sodium_current__R * var_sodium_current__T)) * (exp(((var_sodium_current__V - var_sodium_current__E_Na) * var_sodium_current__F) / (var_sodium_current__R * var_sodium_current__T)) - 1.0)) / (exp((var_sodium_current__V * var_sodium_current__F) / (var_sodium_current__R * var_sodium_current__T)) - 1.0);
    const double var_membrane__i_Na = var_sodium_current__i_Na;
    const double var_L_type_Ca_channel__k_Ca = 0.025;
    const double var_L_type_Ca_channel__Ca_d = var_intracellular_ion_concentrations__Ca_d;
    const double var_L_type_Ca_channel__f_Ca = var_L_type_Ca_channel__Ca_d / (var_L_type_Ca_channel__Ca_d + var_L_type_Ca_channel__k_Ca);
    const double var_L_type_Ca_channel__E_Ca_app = 60.0;
    const double var_L_type_Ca_channel__g_Ca_L = 6.75*mScaleFactorGCaL;
    const double var_L_type_Ca_channel__d_L = var_L_type_Ca_channel_d_L_gate__d_L;
    const double var_L_type_Ca_channel__f_L2 = var_L_type_Ca_channel_f_L2_gate__f_L2;
    const double var_L_type_Ca_channel__V = var_membrane__V;
    const double var_L_type_Ca_channel__f_L1 = var_L_type_Ca_channel_f_L1_gate__f_L1;
    const double var_L_type_Ca_channel__i_Ca_L = var_L_type_Ca_channel__g_Ca_L * var_L_type_Ca_channel__d_L * ((var_L_type_Ca_channel__f_Ca * var_L_type_Ca_channel__f_L1) + ((1.0 - var_L_type_Ca_channel__f_Ca) * var_L_type_Ca_channel__f_L2)) * (var_L_type_Ca_channel__V - var_L_type_Ca_channel__E_Ca_app);
    const double var_membrane__i_Ca_L = var_L_type_Ca_channel__i_Ca_L;
    const double var_Ca_independent_transient_outward_K_current__V = var_membrane__V;
    const double var_Ca_independent_transient_outward_K_current__g_t = 8.25*mScaleFactorIto;
    const double var_Ca_independent_transient_outward_K_current__F = var_membrane__F;
    const double var_Ca_independent_transient_outward_K_current__K_c = var_cleft_space_ion_concentrations__K_c;
    const double var_Ca_independent_transient_outward_K_current__T = var_membrane__T;
    const double var_Ca_independent_transient_outward_K_current__K_i = var_intracellular_ion_concentrations__K_i;
    const double var_Ca_independent_transient_outward_K_current__R = var_membrane__R;
    const double var_Ca_independent_transient_outward_K_current__E_K = ((var_Ca_independent_transient_outward_K_current__R * var_Ca_independent_transient_outward_K_current__T) / var_Ca_independent_transient_outward_K_current__F) * log(var_Ca_independent_transient_outward_K_current__K_c / var_Ca_independent_transient_outward_K_current__K_i);
    const double var_Ca_independent_transient_outward_K_current__r = var_Ca_independent_transient_outward_K_current_r_gate__r;
    const double var_Ca_independent_transient_outward_K_current__s = var_Ca_independent_transient_outward_K_current_s_gate__s;
    const double var_Ca_independent_transient_outward_K_current__i_t = var_Ca_independent_transient_outward_K_current__g_t * var_Ca_independent_transient_outward_K_current__r * var_Ca_independent_transient_outward_K_current__s * (var_Ca_independent_transient_outward_K_current__V - var_Ca_independent_transient_outward_K_current__E_K);
    const double var_membrane__i_t = var_Ca_independent_transient_outward_K_current__i_t;
    const double var_ultra_rapid_K_current__g_kur = 2.25*mScaleFactorGKur;
    const double var_ultra_rapid_K_current__V = var_membrane__V;
    const double var_ultra_rapid_K_current__E_K = var_Ca_independent_transient_outward_K_current__E_K;
    const double var_ultra_rapid_K_current__a_ur = var_ultra_rapid_K_current_aur_gate__a_ur;
    const double var_ultra_rapid_K_current__i_ur = var_ultra_rapid_K_current_iur_gate__i_ur;
    const double var_ultra_rapid_K_current__i_Kur = var_ultra_rapid_K_current__g_kur * var_ultra_rapid_K_current__a_ur * var_ultra_rapid_K_current__i_ur * (var_ultra_rapid_K_current__V - var_ultra_rapid_K_current__E_K);
    const double var_membrane__i_Kur = var_ultra_rapid_K_current__i_Kur;
    const double var_inward_rectifier__T = var_membrane__T;
    const double var_inward_rectifier__V = var_membrane__V;
    const double var_inward_rectifier__g_K1 = 3.1*mScaleFactorGK1;
    const double var_inward_rectifier__R = var_membrane__R;
    const double var_inward_rectifier__K_c = var_cleft_space_ion_concentrations__K_c;
    const double var_inward_rectifier__F = var_membrane__F;
    const double var_inward_rectifier__E_K = var_Ca_independent_transient_outward_K_current__E_K;
    const double var_inward_rectifier__i_K1 = (var_inward_rectifier__g_K1 * pow(var_inward_rectifier__K_c / 1.0, 0.4457) * (var_inward_rectifier__V - var_inward_rectifier__E_K)) / (1.0 + exp((1.5 * ((var_inward_rectifier__V - var_inward_rectifier__E_K) + 3.6) * var_inward_rectifier__F) / (var_inward_rectifier__R * var_inward_rectifier__T)));
    const double var_membrane__i_K1 = var_inward_rectifier__i_K1;
    const double var_delayed_rectifier_K_currents__V = var_membrane__V;
    const double var_delayed_rectifier_K_currents_pi_gate__V = var_delayed_rectifier_K_currents__V;
    const double var_delayed_rectifier_K_currents_pi_gate__pip = 1.0 / (1.0 + exp((var_delayed_rectifier_K_currents_pi_gate__V + 55.0) / 24.0));
    const double var_delayed_rectifier_K_currents__pip = var_delayed_rectifier_K_currents_pi_gate__pip;
    const double var_delayed_rectifier_K_currents_pa_gate__AZD = mScaleFactorAZD;
    const double var_delayed_rectifier_K_currents__AZD = var_delayed_rectifier_K_currents_pa_gate__AZD;
    const double var_delayed_rectifier_K_currents__factorAZD = (1.0 - (1.0 / (1.0 + exp((-(var_delayed_rectifier_K_currents__AZD - 0.6)) / 0.12)))) / 0.9933;
    const double var_delayed_rectifier_K_currents__E_K = var_Ca_independent_transient_outward_K_current__E_K;
    const double var_delayed_rectifier_K_currents__g_Kr = 0.5*mScaleFactorGkr;
    const double var_delayed_rectifier_K_currents__pa = var_delayed_rectifier_K_currents_pa_gate__pa;
    const double var_delayed_rectifier_K_currents__i_Kr = var_delayed_rectifier_K_currents__g_Kr * var_delayed_rectifier_K_currents__factorAZD * var_delayed_rectifier_K_currents__pa * var_delayed_rectifier_K_currents__pip * (var_delayed_rectifier_K_currents__V - var_delayed_rectifier_K_currents__E_K);
    const double var_membrane__i_Kr = var_delayed_rectifier_K_currents__i_Kr;
    const double var_delayed_rectifier_K_currents__n = var_delayed_rectifier_K_currents_n_gate__n;
    const double var_delayed_rectifier_K_currents__g_Ks = 1.0*mScaleFactorGks;
    const double var_delayed_rectifier_K_currents__i_Ks = var_delayed_rectifier_K_currents__g_Ks * var_delayed_rectifier_K_currents__n * (var_delayed_rectifier_K_currents__V - var_delayed_rectifier_K_currents__E_K);
    const double var_membrane__i_Ks = var_delayed_rectifier_K_currents__i_Ks;
    const double var_background_currents__E_Na = var_sodium_current__E_Na;
    const double var_background_currents__g_B_Na = 0.060599;
    const double var_background_currents__V = var_membrane__V;
    const double var_background_currents__i_B_Na = var_background_currents__g_B_Na * (var_background_currents__V - var_background_currents__E_Na);
    const double var_membrane__i_B_Na = var_background_currents__i_B_Na;
    const double var_background_currents__Ca_c = var_cleft_space_ion_concentrations__Ca_c;
    const double var_background_currents__R = var_membrane__R;
    const double var_background_currents__Ca_i = var_intracellular_ion_concentrations__Ca_i;
    const double var_background_currents__F = var_membrane__F;
    const double var_background_currents__T = var_membrane__T;
    const double var_background_currents__E_Ca = ((var_background_currents__R * var_background_currents__T) / (2.0 * var_background_currents__F)) * log(var_background_currents__Ca_c / var_background_currents__Ca_i);
    const double var_background_currents__g_B_Ca = 0.078681;
    const double var_background_currents__i_B_Ca = var_background_currents__g_B_Ca * (var_background_currents__V - var_background_currents__E_Ca);
    const double var_membrane__i_B_Ca = var_background_currents__i_B_Ca;
    const double var_sodium_potassium_pump__K_c = var_cleft_space_ion_concentrations__K_c;
    const double var_sodium_potassium_pump__pow_K_NaK_Na_15 = 36.4829;
    const double var_sodium_potassium_pump__Na_i = var_intracellular_ion_concentrations__Na_i;
    const double var_sodium_potassium_pump__pow_Na_i_15 = pow(var_sodium_potassium_pump__Na_i, 1.5);
    const double var_sodium_potassium_pump__V = var_membrane__V;
    const double var_sodium_potassium_pump__i_NaK_max = 68.55*mScaleFactorGNaK;
    const double var_sodium_potassium_pump__K_NaK_K = 1.0;
    const double var_sodium_potassium_pump__i_NaK = (((((var_sodium_potassium_pump__i_NaK_max * var_sodium_potassium_pump__K_c) / (var_sodium_potassium_pump__K_c + var_sodium_potassium_pump__K_NaK_K)) * var_sodium_potassium_pump__pow_Na_i_15) / (var_sodium_potassium_pump__pow_Na_i_15 + var_sodium_potassium_pump__pow_K_NaK_Na_15)) * (var_sodium_potassium_pump__V + 150.0)) / (var_sodium_potassium_pump__V + 200.0);
    const double var_membrane__i_NaK = var_sodium_potassium_pump__i_NaK;
    const double var_sarcolemmal_calcium_pump_current__i_CaP_max = 4.0;
    const double var_sarcolemmal_calcium_pump_current__k_CaP = 0.0002;
    const double var_sarcolemmal_calcium_pump_current__Ca_i = var_intracellular_ion_concentrations__Ca_i;
    const double var_sarcolemmal_calcium_pump_current__i_CaP = (var_sarcolemmal_calcium_pump_current__i_CaP_max * var_sarcolemmal_calcium_pump_current__Ca_i) / (var_sarcolemmal_calcium_pump_current__Ca_i + var_sarcolemmal_calcium_pump_current__k_CaP);
    const double var_membrane__i_CaP = var_sarcolemmal_calcium_pump_current__i_CaP;
    const double var_Na_Ca_ion_exchanger_current__Ca_c = var_cleft_space_ion_concentrations__Ca_c;
    const double var_Na_Ca_ion_exchanger_current__Na_i = var_intracellular_ion_concentrations__Na_i;
    const double var_Na_Ca_ion_exchanger_current__gamma_Na = 0.45;
    const double var_Na_Ca_ion_exchanger_current__Ca_i = var_intracellular_ion_concentrations__Ca_i;
    const double var_Na_Ca_ion_exchanger_current__K_NaCa = 0.0374842*mScaleFactorGNaCa;
    const double var_Na_Ca_ion_exchanger_current__F = var_membrane__F;
    const double var_Na_Ca_ion_exchanger_current__d_NaCa = 0.0003;
    const double var_Na_Ca_ion_exchanger_current__R = var_membrane__R;
    const double var_Na_Ca_ion_exchanger_current__Na_c = var_cleft_space_ion_concentrations__Na_c;
    const double var_Na_Ca_ion_exchanger_current__V = var_membrane__V;
    const double var_Na_Ca_ion_exchanger_current__T = var_membrane__T;
    const double var_Na_Ca_ion_exchanger_current__i_NaCa = (var_Na_Ca_ion_exchanger_current__K_NaCa * ((var_Na_Ca_ion_exchanger_current__Na_i * var_Na_Ca_ion_exchanger_current__Na_i * var_Na_Ca_ion_exchanger_current__Na_i * var_Na_Ca_ion_exchanger_current__Ca_c * exp((var_Na_Ca_ion_exchanger_current__F * var_Na_Ca_ion_exchanger_current__V * var_Na_Ca_ion_exchanger_current__gamma_Na) / (var_Na_Ca_ion_exchanger_current__R * var_Na_Ca_ion_exchanger_current__T))) - (var_Na_Ca_ion_exchanger_current__Na_c * var_Na_Ca_ion_exchanger_current__Na_c * var_Na_Ca_ion_exchanger_current__Na_c * var_Na_Ca_ion_exchanger_current__Ca_i * exp(((var_Na_Ca_ion_exchanger_current__gamma_Na - 1.0) * var_Na_Ca_ion_exchanger_current__V * var_Na_Ca_ion_exchanger_current__F) / (var_Na_Ca_ion_exchanger_current__R * var_Na_Ca_ion_exchanger_current__T))))) / (1.0 + (var_Na_Ca_ion_exchanger_current__d_NaCa * ((var_Na_Ca_ion_exchanger_current__Na_c * var_Na_Ca_ion_exchanger_current__Na_c * var_Na_Ca_ion_exchanger_current__Na_c * var_Na_Ca_ion_exchanger_current__Ca_i) + (var_Na_Ca_ion_exchanger_current__Na_i * var_Na_Ca_ion_exchanger_current__Na_i * var_Na_Ca_ion_exchanger_current__Na_i * var_Na_Ca_ion_exchanger_current__Ca_c))));
    const double var_membrane__i_NaCa = var_Na_Ca_ion_exchanger_current__i_NaCa;
    const double var_ACh_dependent_K_current__Cm = var_membrane__Cm;
    const double var_ACh_dependent_K_current__V = var_membrane__V;
    const double var_ACh_dependent_K_current__E_K = var_Ca_independent_transient_outward_K_current__E_K;
    const double var_ACh_dependent_K_current__ACh = mScaleFactorAch;
    const double var_ACh_dependent_K_current__i_KACh = (10000.0 / (1.0 + ((9.13652 * pow(1.0, 0.477811)) / pow(var_ACh_dependent_K_current__ACh, 0.477811)))) * (0.0517 + (0.4516 / (1.0 + exp((var_ACh_dependent_K_current__V + 59.53) / 17.18)))) * (var_ACh_dependent_K_current__V - var_ACh_dependent_K_current__E_K) * var_ACh_dependent_K_current__Cm;
    const double var_membrane__i_KACh = var_ACh_dependent_K_current__i_KACh;
    double var_membrane__i_Stim = GetStimulus((1.0/0.001)*var_environment__time);
    const double var_membrane__I = var_membrane__i_Na + var_membrane__i_Ca_L + var_membrane__i_t + var_membrane__i_Kur + var_membrane__i_K1 + var_membrane__i_Kr + var_membrane__i_Ks + var_membrane__i_B_Na + var_membrane__i_B_Ca + var_membrane__i_NaK + var_membrane__i_CaP + var_membrane__i_NaCa + var_membrane__i_KACh + var_membrane__i_Stim;
    const double var_sodium_current_m_gate__V = var_sodium_current__V;
    const double var_sodium_current_m_gate__m_infinity = 1.0 / (1.0 + exp((var_sodium_current_m_gate__V + 27.12) / (-8.21)));
    const double var_sodium_current_m_gate__m_factor = (var_sodium_current_m_gate__V + 25.57) / 28.8;
    const double var_sodium_current_m_gate__tau_m = (4.2e-05 * exp((-var_sodium_current_m_gate__m_factor) * var_sodium_current_m_gate__m_factor)) + 2.4e-05;
    const double var_sodium_current_h1_gate__V = var_sodium_current__V;
    const double var_sodium_current_h1_gate__h_infinity = 1.0 / (1.0 + exp((var_sodium_current_h1_gate__V + 63.6) / 5.3));
    const double var_sodium_current_h1_gate__h_factor = 1.0 / (1.0 + exp((var_sodium_current_h1_gate__V + 35.1) / 3.2));
    const double var_sodium_current_h1_gate__tau_h1 = (0.03 * var_sodium_current_h1_gate__h_factor) + 0.0003;
    const double var_sodium_current_h2_gate__h_infinity = var_sodium_current_h1_gate__h_infinity;
    const double var_sodium_current_h2_gate__h_factor = var_sodium_current_h1_gate__h_factor;
    const double var_sodium_current_h2_gate__tau_h2 = (0.12 * var_sodium_current_h2_gate__h_factor) + 0.003;
    const double var_L_type_Ca_channel_d_L_gate__V = var_L_type_Ca_channel__V;
    const double var_L_type_Ca_channel_d_L_gate__d_L_infinity = 1.0 / (1.0 + exp((var_L_type_Ca_channel_d_L_gate__V + 9.0) / (-5.8)));
    const double var_L_type_Ca_channel_d_L_gate__d_L_factor = (var_L_type_Ca_channel_d_L_gate__V + 35.0) / 30.0;
    const double var_L_type_Ca_channel_d_L_gate__tau_d_L = (0.0027 * exp((-var_L_type_Ca_channel_d_L_gate__d_L_factor) * var_L_type_Ca_channel_d_L_gate__d_L_factor)) + 0.002;
    const double var_L_type_Ca_channel_f_L1_gate__V = var_L_type_Ca_channel__V;
    const double var_L_type_Ca_channel_f_L1_gate__f_L_infinity = 1.0 / (1.0 + exp((var_L_type_Ca_channel_f_L1_gate__V + 27.4) / 7.1));
    const double var_L_type_Ca_channel_f_L1_gate__f_L_factor = var_L_type_Ca_channel_f_L1_gate__V + 40.0;
    const double var_L_type_Ca_channel_f_L1_gate__tau_f_L1 = (0.161 * exp((((-var_L_type_Ca_channel_f_L1_gate__f_L_factor) * var_L_type_Ca_channel_f_L1_gate__f_L_factor) / 14.4) / 14.4)) + 0.01;
    const double var_L_type_Ca_channel_f_L2_gate__f_L_factor = var_L_type_Ca_channel_f_L1_gate__f_L_factor;
    const double var_L_type_Ca_channel_f_L2_gate__tau_f_L2 = (1.3323 * exp((((-var_L_type_Ca_channel_f_L2_gate__f_L_factor) * var_L_type_Ca_channel_f_L2_gate__f_L_factor) / 14.2) / 14.2)) + 0.0626;
    const double var_L_type_Ca_channel_f_L2_gate__f_L_infinity = var_L_type_Ca_channel_f_L1_gate__f_L_infinity;
    const double var_Ca_independent_transient_outward_K_current_r_gate__V = var_Ca_independent_transient_outward_K_current__V;
    const double var_Ca_independent_transient_outward_K_current_r_gate__tau_r = (0.0035 * exp((((-var_Ca_independent_transient_outward_K_current_r_gate__V) * var_Ca_independent_transient_outward_K_current_r_gate__V) / 30.0) / 30.0)) + 0.0015;
    const double var_Ca_independent_transient_outward_K_current_r_gate__r_infinity = 1.0 / (1.0 + exp((var_Ca_independent_transient_outward_K_current_r_gate__V - 1.0) / (-11.0)));
    const double var_Ca_independent_transient_outward_K_current_s_gate__V = var_Ca_independent_transient_outward_K_current__V;
    const double var_Ca_independent_transient_outward_K_current_s_gate__s_factor = (var_Ca_independent_transient_outward_K_current_s_gate__V + 52.45) / 15.8827;
    const double var_Ca_independent_transient_outward_K_current_s_gate__tau_s = (0.025635 * exp((-var_Ca_independent_transient_outward_K_current_s_gate__s_factor) * var_Ca_independent_transient_outward_K_current_s_gate__s_factor)) + 0.01414;
    const double var_Ca_independent_transient_outward_K_current_s_gate__s_infinity = 1.0 / (1.0 + exp((var_Ca_independent_transient_outward_K_current_s_gate__V + 40.5) / 11.5));
    const double var_ultra_rapid_K_current_aur_gate__V = var_ultra_rapid_K_current__V;
    const double var_ultra_rapid_K_current_aur_gate__a_ur_infinity = 1.0 / (1.0 + exp((-(var_ultra_rapid_K_current_aur_gate__V + 6.0)) / 8.6));
    const double var_ultra_rapid_K_current_aur_gate__tau_a_ur = (0.009 / (1.0 + exp((var_ultra_rapid_K_current_aur_gate__V + 5.0) / 12.0))) + 0.0005;
    const double var_ultra_rapid_K_current_iur_gate__V = var_ultra_rapid_K_current__V;
    const double var_ultra_rapid_K_current_iur_gate__i_ur_infinity = 1.0 / (1.0 + exp((var_ultra_rapid_K_current_iur_gate__V + 7.5) / 10.0));
    const double var_ultra_rapid_K_current_iur_gate__tau_i_ur = (0.59 / (1.0 + exp((var_ultra_rapid_K_current_iur_gate__V + 60.0) / 10.0))) + 3.05;
    const double var_delayed_rectifier_K_currents_n_gate__V = var_delayed_rectifier_K_currents__V;
    const double var_delayed_rectifier_K_currents_n_gate__n_factor = (var_delayed_rectifier_K_currents_n_gate__V - 20.0) / 20.0;
    const double var_delayed_rectifier_K_currents_n_gate__tau_n = 0.7 + (0.4 * exp((-var_delayed_rectifier_K_currents_n_gate__n_factor) * var_delayed_rectifier_K_currents_n_gate__n_factor));
    const double var_delayed_rectifier_K_currents_n_gate__n_infinity = 1.0 / (1.0 + exp((var_delayed_rectifier_K_currents_n_gate__V - 19.9) / (-12.7)));
    const double var_delayed_rectifier_K_currents_pa_gate__V = var_delayed_rectifier_K_currents__V;
    const double var_delayed_rectifier_K_currents_pa_gate__pa_factor = (var_delayed_rectifier_K_currents_pa_gate__V + 20.1376) / 22.1996;
    const double var_delayed_rectifier_K_currents_pa_gate__tau_pa = 0.03118 + (0.21718 * exp((-var_delayed_rectifier_K_currents_pa_gate__pa_factor) * var_delayed_rectifier_K_currents_pa_gate__pa_factor));
    const double var_delayed_rectifier_K_currents_pa_gate__p_a_infinity = 1.0 / (1.0 + exp((var_delayed_rectifier_K_currents_pa_gate__V + 15.0 + (10.0 * var_delayed_rectifier_K_currents_pa_gate__AZD)) / (-6.0)));
    const double var_intracellular_ion_concentrations__phi_Na_en = 0.0;
    const double var_intracellular_ion_concentrations__Vol_i = 0.005884;
    const double var_intracellular_ion_concentrations__Vol_d = 0.00011768;
    const double var_intracellular_ion_concentrations__tau_di = 0.01;
    const double var_intracellular_ion_concentrations__F = var_membrane__F;
    const double var_intracellular_ion_concentrations__i_di = ((var_intracellular_ion_concentrations__Ca_d - var_intracellular_ion_concentrations__Ca_i) * 2.0 * var_intracellular_ion_concentrations__Vol_d * var_intracellular_ion_concentrations__F) / var_intracellular_ion_concentrations__tau_di;
    const double var_intracellular_ion_concentrations__i_Na = var_sodium_current__i_Na;
    const double var_intracellular_ion_concentrations__i_Ca_L = var_L_type_Ca_channel__i_Ca_L;
    const double var_intracellular_ion_concentrations__i_t = var_Ca_independent_transient_outward_K_current__i_t;
    const double var_intracellular_ion_concentrations__i_Kur = var_ultra_rapid_K_current__i_Kur;
    const double var_intracellular_ion_concentrations__i_K1 = var_inward_rectifier__i_K1;
    const double var_intracellular_ion_concentrations__i_Kr = var_delayed_rectifier_K_currents__i_Kr;
    const double var_intracellular_ion_concentrations__i_Ks = var_delayed_rectifier_K_currents__i_Ks;
    const double var_intracellular_ion_concentrations__i_B_Na = var_background_currents__i_B_Na;
    const double var_intracellular_ion_concentrations__i_B_Ca = var_background_currents__i_B_Ca;
    const double var_intracellular_ion_concentrations__i_NaK = var_sodium_potassium_pump__i_NaK;
    const double var_intracellular_ion_concentrations__i_CaP = var_sarcolemmal_calcium_pump_current__i_CaP;
    const double var_intracellular_ion_concentrations__i_NaCa = var_Na_Ca_ion_exchanger_current__i_NaCa;
    const double var_intracellular_ion_concentrations__i_KACh = var_ACh_dependent_K_current__i_KACh;
    const double var_Ca_handling_by_the_SR__k_cyca = 0.0003;
    const double var_Ca_handling_by_the_SR__k_xcs = 0.4;
    const double var_Ca_handling_by_the_SR__k_srca = 0.5;
    const double var_Ca_handling_by_the_SR__Ca_i = var_intracellular_ion_concentrations__Ca_i;
    const double var_Ca_handling_by_the_SR__I_up_max = 2800.0;
    const double var_Ca_handling_by_the_SR__i_up = (var_Ca_handling_by_the_SR__I_up_max * ((var_Ca_handling_by_the_SR__Ca_i / var_Ca_handling_by_the_SR__k_cyca) - ((var_Ca_handling_by_the_SR__k_xcs * var_Ca_handling_by_the_SR__k_xcs * var_Ca_handling_by_the_SR__Ca_up) / var_Ca_handling_by_the_SR__k_srca))) / (((var_Ca_handling_by_the_SR__Ca_i + var_Ca_handling_by_the_SR__k_cyca) / var_Ca_handling_by_the_SR__k_cyca) + ((var_Ca_handling_by_the_SR__k_xcs * (var_Ca_handling_by_the_SR__Ca_up + var_Ca_handling_by_the_SR__k_srca)) / var_Ca_handling_by_the_SR__k_srca));
    const double var_intracellular_ion_concentrations__i_up = var_Ca_handling_by_the_SR__i_up;
    const double var_Ca_handling_by_the_SR__alpha_rel = 200000.0;
    const double var_Ca_handling_by_the_SR__i_rel_f2 = var_Ca_handling_by_the_SR__F2 / (var_Ca_handling_by_the_SR__F2 + 0.25);
    const double var_Ca_handling_by_the_SR__i_rel_factor = var_Ca_handling_by_the_SR__i_rel_f2 * var_Ca_handling_by_the_SR__i_rel_f2;
    const double var_Ca_handling_by_the_SR__i_rel = var_Ca_handling_by_the_SR__alpha_rel * var_Ca_handling_by_the_SR__i_rel_factor * (var_Ca_handling_by_the_SR__Ca_rel - var_Ca_handling_by_the_SR__Ca_i);
    const double var_intracellular_ion_concentrations__i_rel = var_Ca_handling_by_the_SR__i_rel;
    const double var_intracellular_ion_concentrations__i_Stim = var_membrane__i_Stim;
    const double var_intracellular_Ca_buffering__Ca_i = var_intracellular_ion_concentrations__Ca_i;
    const double var_intracellular_Ca_buffering__J_O_TMgC = (200000.0 * var_intracellular_Ca_buffering__Ca_i * ((1.0 - var_intracellular_Ca_buffering__O_TMgC) - var_intracellular_Ca_buffering__O_TMgMg)) - (6.6 * var_intracellular_Ca_buffering__O_TMgC);
    const double var_intracellular_Ca_buffering__J_O_TC = (78400.0 * var_intracellular_Ca_buffering__Ca_i * (1.0 - var_intracellular_Ca_buffering__O_TC)) - (392.0 * var_intracellular_Ca_buffering__O_TC);
    const double var_intracellular_Ca_buffering__J_O_C = (200000.0 * var_intracellular_Ca_buffering__Ca_i * (1.0 - var_intracellular_Ca_buffering__O_C)) - (476.0 * var_intracellular_Ca_buffering__O_C);
    const double var_intracellular_Ca_buffering__J_O = (0.08 * var_intracellular_Ca_buffering__J_O_TC) + (0.16 * var_intracellular_Ca_buffering__J_O_TMgC) + (0.045 * var_intracellular_Ca_buffering__J_O_C);
    const double var_intracellular_ion_concentrations__J_O = var_intracellular_Ca_buffering__J_O;
    const double var_intracellular_Ca_buffering__Mg_i = 2.5;
    const double var_intracellular_Ca_buffering__J_O_TMgMg = (2000.0 * var_intracellular_Ca_buffering__Mg_i * ((1.0 - var_intracellular_Ca_buffering__O_TMgC) - var_intracellular_Ca_buffering__O_TMgMg)) - (666.0 * var_intracellular_Ca_buffering__O_TMgMg);
    const double var_cleft_space_ion_concentrations__Vol_c = 0.000800224;
    const double var_cleft_space_ion_concentrations__tau_Na = 14.3;
    const double var_cleft_space_ion_concentrations__tau_K = 10.0;
    const double var_cleft_space_ion_concentrations__tau_Ca = 24.7;
    const double var_cleft_space_ion_concentrations__Na_b = 130.0;
    const double var_cleft_space_ion_concentrations__Ca_b = 1.8;
    const double var_cleft_space_ion_concentrations__K_b = 5.4;
    const double var_cleft_space_ion_concentrations__F = var_membrane__F;
    const double var_cleft_space_ion_concentrations__i_Na = var_sodium_current__i_Na;
    const double var_cleft_space_ion_concentrations__i_Ca_L = var_L_type_Ca_channel__i_Ca_L;
    const double var_cleft_space_ion_concentrations__i_t = var_Ca_independent_transient_outward_K_current__i_t;
    const double var_cleft_space_ion_concentrations__i_Kur = var_ultra_rapid_K_current__i_Kur;
    const double var_cleft_space_ion_concentrations__i_K1 = var_inward_rectifier__i_K1;
    const double var_cleft_space_ion_concentrations__i_Kr = var_delayed_rectifier_K_currents__i_Kr;
    const double var_cleft_space_ion_concentrations__i_Ks = var_delayed_rectifier_K_currents__i_Ks;
    const double var_cleft_space_ion_concentrations__i_B_Na = var_background_currents__i_B_Na;
    const double var_cleft_space_ion_concentrations__i_B_Ca = var_background_currents__i_B_Ca;
    const double var_cleft_space_ion_concentrations__i_NaK = var_sodium_potassium_pump__i_NaK;
    const double var_cleft_space_ion_concentrations__i_CaP = var_sarcolemmal_calcium_pump_current__i_CaP;
    const double var_cleft_space_ion_concentrations__i_NaCa = var_Na_Ca_ion_exchanger_current__i_NaCa;
    const double var_cleft_space_ion_concentrations__phi_Na_en = var_intracellular_ion_concentrations__phi_Na_en;
    const double var_Ca_handling_by_the_SR__tau_tr = 0.01;
    const double var_Ca_handling_by_the_SR__Vol_rel = 4.41e-05;
    const double var_Ca_handling_by_the_SR__F = var_membrane__F;
    const double var_Ca_handling_by_the_SR__i_tr = ((var_Ca_handling_by_the_SR__Ca_up - var_Ca_handling_by_the_SR__Ca_rel) * 2.0 * var_Ca_handling_by_the_SR__Vol_rel * var_Ca_handling_by_the_SR__F) / var_Ca_handling_by_the_SR__tau_tr;
    const double var_Ca_handling_by_the_SR__Vol_up = 0.0003969;
    const double var_Ca_handling_by_the_SR__k_rel_i = 0.0003;
    const double var_Ca_handling_by_the_SR__r_Ca_i_term = var_Ca_handling_by_the_SR__Ca_i / (var_Ca_handling_by_the_SR__Ca_i + var_Ca_handling_by_the_SR__k_rel_i);
    const double var_Ca_handling_by_the_SR__r_Ca_i_factor = var_Ca_handling_by_the_SR__r_Ca_i_term * var_Ca_handling_by_the_SR__r_Ca_i_term * var_Ca_handling_by_the_SR__r_Ca_i_term * var_Ca_handling_by_the_SR__r_Ca_i_term;
    const double var_Ca_handling_by_the_SR__Ca_d = var_intracellular_ion_concentrations__Ca_d;
    const double var_Ca_handling_by_the_SR__k_rel_d = 0.003;
    const double var_Ca_handling_by_the_SR__r_Ca_d_term = var_Ca_handling_by_the_SR__Ca_d / (var_Ca_handling_by_the_SR__Ca_d + var_Ca_handling_by_the_SR__k_rel_d);
    const double var_Ca_handling_by_the_SR__r_Ca_d_factor = var_Ca_handling_by_the_SR__r_Ca_d_term * var_Ca_handling_by_the_SR__r_Ca_d_term * var_Ca_handling_by_the_SR__r_Ca_d_term * var_Ca_handling_by_the_SR__r_Ca_d_term;
    const double var_Ca_handling_by_the_SR__r_act = 203.8 * (var_Ca_handling_by_the_SR__r_Ca_i_factor + var_Ca_handling_by_the_SR__r_Ca_d_factor);
    const double var_Ca_handling_by_the_SR__r_inact = 33.96 + (339.6 * var_Ca_handling_by_the_SR__r_Ca_i_factor);
    const double var_Ca_handling_by_the_SR__r_recov = 0.815;
    const double var_Ca_handling_by_the_SR__J_O_Calse = (480.0 * var_Ca_handling_by_the_SR__Ca_rel * (1.0 - var_Ca_handling_by_the_SR__O_Calse)) - (400.0 * var_Ca_handling_by_the_SR__O_Calse);

    double d_dt_membrane__V;
    if (mSetVoltageDerivativeToZero)
    {
        d_dt_membrane__V = 0.0;
    }
    else
    {
        d_dt_membrane__V = (-var_membrane__I) / var_membrane__Cm;
    }

    const double d_dt_sodium_current_m_gate__m = (var_sodium_current_m_gate__m_infinity - var_sodium_current_m_gate__m) / var_sodium_current_m_gate__tau_m;
    const double d_dt_sodium_current_h1_gate__h1 = (var_sodium_current_h1_gate__h_infinity - var_sodium_current_h1_gate__h1) / var_sodium_current_h1_gate__tau_h1;
    const double d_dt_sodium_current_h2_gate__h2 = (var_sodium_current_h2_gate__h_infinity - var_sodium_current_h2_gate__h2) / var_sodium_current_h2_gate__tau_h2;
    const double d_dt_L_type_Ca_channel_d_L_gate__d_L = (var_L_type_Ca_channel_d_L_gate__d_L_infinity - var_L_type_Ca_channel_d_L_gate__d_L) / var_L_type_Ca_channel_d_L_gate__tau_d_L;
    const double d_dt_L_type_Ca_channel_f_L1_gate__f_L1 = (var_L_type_Ca_channel_f_L1_gate__f_L_infinity - var_L_type_Ca_channel_f_L1_gate__f_L1) / var_L_type_Ca_channel_f_L1_gate__tau_f_L1;
    const double d_dt_L_type_Ca_channel_f_L2_gate__f_L2 = (var_L_type_Ca_channel_f_L2_gate__f_L_infinity - var_L_type_Ca_channel_f_L2_gate__f_L2) / var_L_type_Ca_channel_f_L2_gate__tau_f_L2;
    const double d_dt_Ca_independent_transient_outward_K_current_r_gate__r = (var_Ca_independent_transient_outward_K_current_r_gate__r_infinity - var_Ca_independent_transient_outward_K_current_r_gate__r) / var_Ca_independent_transient_outward_K_current_r_gate__tau_r;
    const double d_dt_Ca_independent_transient_outward_K_current_s_gate__s = (var_Ca_independent_transient_outward_K_current_s_gate__s_infinity - var_Ca_independent_transient_outward_K_current_s_gate__s) / var_Ca_independent_transient_outward_K_current_s_gate__tau_s;
    const double d_dt_ultra_rapid_K_current_aur_gate__a_ur = (var_ultra_rapid_K_current_aur_gate__a_ur_infinity - var_ultra_rapid_K_current_aur_gate__a_ur) / var_ultra_rapid_K_current_aur_gate__tau_a_ur;
    const double d_dt_ultra_rapid_K_current_iur_gate__i_ur = (var_ultra_rapid_K_current_iur_gate__i_ur_infinity - var_ultra_rapid_K_current_iur_gate__i_ur) / var_ultra_rapid_K_current_iur_gate__tau_i_ur;
    const double d_dt_delayed_rectifier_K_currents_n_gate__n = (var_delayed_rectifier_K_currents_n_gate__n_infinity - var_delayed_rectifier_K_currents_n_gate__n) / var_delayed_rectifier_K_currents_n_gate__tau_n;
    const double d_dt_delayed_rectifier_K_currents_pa_gate__pa = (var_delayed_rectifier_K_currents_pa_gate__p_a_infinity - var_delayed_rectifier_K_currents_pa_gate__pa) / var_delayed_rectifier_K_currents_pa_gate__tau_pa;
    const double d_dt_intracellular_ion_concentrations__K_i = (-(((var_intracellular_ion_concentrations__i_t + var_intracellular_ion_concentrations__i_Kur + var_intracellular_ion_concentrations__i_K1 + var_intracellular_ion_concentrations__i_Ks + var_intracellular_ion_concentrations__i_Kr + var_intracellular_ion_concentrations__i_KACh) - (2.0 * var_intracellular_ion_concentrations__i_NaK)) + var_intracellular_ion_concentrations__i_Stim)) / (var_intracellular_ion_concentrations__Vol_i * var_intracellular_ion_concentrations__F);
    const double d_dt_intracellular_ion_concentrations__Na_i = (-(var_intracellular_ion_concentrations__i_Na + var_intracellular_ion_concentrations__i_B_Na + (3.0 * var_intracellular_ion_concentrations__i_NaCa) + (3.0 * var_intracellular_ion_concentrations__i_NaK) + var_intracellular_ion_concentrations__phi_Na_en)) / (var_intracellular_ion_concentrations__Vol_i * var_intracellular_ion_concentrations__F);
    const double d_dt_intracellular_ion_concentrations__Ca_i = ((-((var_intracellular_ion_concentrations__i_B_Ca + var_intracellular_ion_concentrations__i_CaP + var_intracellular_ion_concentrations__i_up) - (var_intracellular_ion_concentrations__i_di + var_intracellular_ion_concentrations__i_rel + (2.0 * var_intracellular_ion_concentrations__i_NaCa)))) / (2.0 * var_intracellular_ion_concentrations__Vol_i * var_intracellular_ion_concentrations__F)) - (1.0 * var_intracellular_ion_concentrations__J_O);
    const double d_dt_intracellular_ion_concentrations__Ca_d = (-(var_intracellular_ion_concentrations__i_Ca_L + var_intracellular_ion_concentrations__i_di)) / (2.0 * var_intracellular_ion_concentrations__Vol_d * var_intracellular_ion_concentrations__F);
    const double d_dt_intracellular_Ca_buffering__O_C = var_intracellular_Ca_buffering__J_O_C;
    const double d_dt_intracellular_Ca_buffering__O_TC = var_intracellular_Ca_buffering__J_O_TC;
    const double d_dt_intracellular_Ca_buffering__O_TMgC = var_intracellular_Ca_buffering__J_O_TMgC;
    const double d_dt_intracellular_Ca_buffering__O_TMgMg = var_intracellular_Ca_buffering__J_O_TMgMg;
    const double d_dt_intracellular_Ca_buffering__O = var_intracellular_Ca_buffering__J_O;
    const double d_dt_cleft_space_ion_concentrations__Ca_c = ((var_cleft_space_ion_concentrations__Ca_b - var_cleft_space_ion_concentrations__Ca_c) / var_cleft_space_ion_concentrations__tau_Ca) + (((var_cleft_space_ion_concentrations__i_Ca_L + var_cleft_space_ion_concentrations__i_B_Ca + var_cleft_space_ion_concentrations__i_CaP) - (2.0 * var_cleft_space_ion_concentrations__i_NaCa)) / (2.0 * var_cleft_space_ion_concentrations__Vol_c * var_cleft_space_ion_concentrations__F));
    const double d_dt_cleft_space_ion_concentrations__K_c = ((var_cleft_space_ion_concentrations__K_b - var_cleft_space_ion_concentrations__K_c) / var_cleft_space_ion_concentrations__tau_K) + (((var_cleft_space_ion_concentrations__i_t + var_cleft_space_ion_concentrations__i_Kur + var_cleft_space_ion_concentrations__i_K1 + var_cleft_space_ion_concentrations__i_Ks + var_cleft_space_ion_concentrations__i_Kr) - (2.0 * var_cleft_space_ion_concentrations__i_NaK)) / (var_cleft_space_ion_concentrations__Vol_c * var_cleft_space_ion_concentrations__F));
    const double d_dt_cleft_space_ion_concentrations__Na_c = ((var_cleft_space_ion_concentrations__Na_b - var_cleft_space_ion_concentrations__Na_c) / var_cleft_space_ion_concentrations__tau_Na) + ((var_cleft_space_ion_concentrations__i_Na + var_cleft_space_ion_concentrations__i_B_Na + (3.0 * var_cleft_space_ion_concentrations__i_NaCa) + (3.0 * var_cleft_space_ion_concentrations__i_NaK) + var_cleft_space_ion_concentrations__phi_Na_en) / (var_cleft_space_ion_concentrations__Vol_c * var_cleft_space_ion_concentrations__F));
    const double d_dt_Ca_handling_by_the_SR__F1 = (var_Ca_handling_by_the_SR__r_recov * ((1.0 - var_Ca_handling_by_the_SR__F1) - var_Ca_handling_by_the_SR__F2)) - (var_Ca_handling_by_the_SR__r_act * var_Ca_handling_by_the_SR__F1);
    const double d_dt_Ca_handling_by_the_SR__F2 = (var_Ca_handling_by_the_SR__r_act * var_Ca_handling_by_the_SR__F1) - (var_Ca_handling_by_the_SR__r_inact * var_Ca_handling_by_the_SR__F2);
    const double d_dt_Ca_handling_by_the_SR__O_Calse = var_Ca_handling_by_the_SR__J_O_Calse;
    const double d_dt_Ca_handling_by_the_SR__Ca_up = (var_Ca_handling_by_the_SR__i_up - var_Ca_handling_by_the_SR__i_tr) / (2.0 * var_Ca_handling_by_the_SR__Vol_up * var_Ca_handling_by_the_SR__F);
    const double d_dt_Ca_handling_by_the_SR__Ca_rel = ((var_Ca_handling_by_the_SR__i_tr - var_Ca_handling_by_the_SR__i_rel) / (2.0 * var_Ca_handling_by_the_SR__Vol_rel * var_Ca_handling_by_the_SR__F)) - (31.0 * var_Ca_handling_by_the_SR__J_O_Calse);

    rDY[0] = 0.001*d_dt_membrane__V;
    rDY[1] = 0.001*d_dt_sodium_current_m_gate__m;
    rDY[2] = 0.001*d_dt_sodium_current_h1_gate__h1;
    rDY[3] = 0.001*d_dt_sodium_current_h2_gate__h2;
    rDY[4] = 0.001*d_dt_L_type_Ca_channel_d_L_gate__d_L;
    rDY[5] = 0.001*d_dt_L_type_Ca_channel_f_L1_gate__f_L1;
    rDY[6] = 0.001*d_dt_L_type_Ca_channel_f_L2_gate__f_L2;
    rDY[7] = 0.001*d_dt_Ca_independent_transient_outward_K_current_r_gate__r;
    rDY[8] = 0.001*d_dt_Ca_independent_transient_outward_K_current_s_gate__s;
    rDY[9] = 0.001*d_dt_ultra_rapid_K_current_aur_gate__a_ur;
    rDY[10] = 0.001*d_dt_ultra_rapid_K_current_iur_gate__i_ur;
    rDY[11] = 0.001*d_dt_delayed_rectifier_K_currents_n_gate__n;
    rDY[12] = 0.001*d_dt_delayed_rectifier_K_currents_pa_gate__pa;
    rDY[13] = 0.001*d_dt_intracellular_ion_concentrations__Na_i;
    rDY[14] = 0.001*d_dt_intracellular_ion_concentrations__Ca_i;
    rDY[15] = 0.001*d_dt_intracellular_ion_concentrations__K_i;
    rDY[16] = 0.001*d_dt_intracellular_ion_concentrations__Ca_d;
    rDY[17] = 0.001*d_dt_intracellular_Ca_buffering__O_C;
    rDY[18] = 0.001*d_dt_intracellular_Ca_buffering__O_TC;
    rDY[19] = 0.001*d_dt_intracellular_Ca_buffering__O_TMgC;
    rDY[20] = 0.001*d_dt_intracellular_Ca_buffering__O_TMgMg;
    rDY[21] = 0.001*d_dt_intracellular_Ca_buffering__O;
    rDY[22] = 0.001*d_dt_cleft_space_ion_concentrations__Na_c;
    rDY[23] = 0.001*d_dt_cleft_space_ion_concentrations__Ca_c;
    rDY[24] = 0.001*d_dt_cleft_space_ion_concentrations__K_c;
    rDY[25] = 0.001*d_dt_Ca_handling_by_the_SR__Ca_rel;
    rDY[26] = 0.001*d_dt_Ca_handling_by_the_SR__Ca_up;
    rDY[27] = 0.001*d_dt_Ca_handling_by_the_SR__O_Calse;
    rDY[28] = 0.001*d_dt_Ca_handling_by_the_SR__F1;
    rDY[29] = 0.001*d_dt_Ca_handling_by_the_SR__F2;
}


template<>
void OdeSystemInformation<Maleckar2009OdeSystem>::Initialise(void)
{
    // Time units: second
    //
    this->mVariableNames.push_back("V");
    this->mVariableUnits.push_back("millivolt");
    this->mInitialConditions.push_back(-73.941851);

    this->mVariableNames.push_back("m");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.003325);

    this->mVariableNames.push_back("h1");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.875262);

    this->mVariableNames.push_back("h2");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.870692);

    this->mVariableNames.push_back("d_L");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.000014);

    this->mVariableNames.push_back("f_L1");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.998578);

    this->mVariableNames.push_back("f_L2");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.998561);

    this->mVariableNames.push_back("r");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.001098);

    this->mVariableNames.push_back("s");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.948202);

    this->mVariableNames.push_back("a_ur");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.000371);

    this->mVariableNames.push_back("i_ur");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.966869);

    this->mVariableNames.push_back("n");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.004661);

    this->mVariableNames.push_back("pa");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.000054);

    this->mVariableNames.push_back("Na_i");
    this->mVariableUnits.push_back("millimolar");
    this->mInitialConditions.push_back(8.488527);

    this->mVariableNames.push_back("Ca_i");
    this->mVariableUnits.push_back("millimolar");
    this->mInitialConditions.push_back(6.5e-5);

    this->mVariableNames.push_back("K_i");
    this->mVariableUnits.push_back("millimolar");
    this->mInitialConditions.push_back(129.502075);

    this->mVariableNames.push_back("Ca_d");
    this->mVariableUnits.push_back("millimolar");
    this->mInitialConditions.push_back(7.1e-5);

    this->mVariableNames.push_back("O_C");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.026604);

    this->mVariableNames.push_back("O_TC");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.012843);

    this->mVariableNames.push_back("O_TMgC");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.190077);

    this->mVariableNames.push_back("O_TMgMg");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.714719);

    this->mVariableNames.push_back("O");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1.38222);

    this->mVariableNames.push_back("Na_c");
    this->mVariableUnits.push_back("millimolar");
    this->mInitialConditions.push_back(130.019282);

    this->mVariableNames.push_back("Ca_c");
    this->mVariableUnits.push_back("millimolar");
    this->mInitialConditions.push_back(1.814418);

    this->mVariableNames.push_back("K_c");
    this->mVariableUnits.push_back("millimolar");
    this->mInitialConditions.push_back(5.588239);

    this->mVariableNames.push_back("Ca_rel");
    this->mVariableUnits.push_back("millimolar");
    this->mInitialConditions.push_back(0.630471);

    this->mVariableNames.push_back("Ca_up");
    this->mVariableUnits.push_back("millimolar");
    this->mInitialConditions.push_back(0.646226);

    this->mVariableNames.push_back("O_Calse");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.43071);

    this->mVariableNames.push_back("F1");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.45453);

    this->mVariableNames.push_back("F2");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.002665);

    this->mInitialised = true;
}


// Serialization for Boost >= 1.36
#include "SerializationExportWrapperForCpp.hpp"
CHASTE_CLASS_EXPORT(Maleckar2009OdeSystem)
